//#region Analog Inputs Constants, Globals and Requires
// Define the configuraton for the I/O
var ANALOG_INPUTS_LOCATION = '/sys/class/hwmon';
var ANALOG_INPUTS_CHIPS_PER_BOARD = 2;// Default = 2
var ANALOG_INPUTS_POINTS_PER_CHIP = 16;// Default = 16
var ANALOG_INPUTS_CYCLE_TIME = 750// Default = 500ms/750ms
var ANALOG_INPUTS_RATE = parseInt(ANALOG_INPUTS_CYCLE_TIME / (ANALOG_INPUTS_CHIPS_PER_BOARD * ANALOG_INPUTS_POINTS_PER_CHIP)*0.9)
var ANALOG_INPUTS_MAXIMUM_RANGE = 25;// Default = 25
var ANALOG_INPUTS_DEFAULT_LOW_THRESHOLD = 0;// Default = 0
var ANALOG_INPUTS_DEFAULT_HIGH_THRESHOLD = ANALOG_INPUTS_MAXIMUM_RANGE;// Default = ANALOG_INPUTS_MAXIMUM_RANGE
var ANALOG_INPUTS_RAWVALUE_OFFSET = -2.1796;// Default = -2.1796
var ANALOG_INPUTS_RAWVALUE_SLOPE = 0.0112;// Default = 0.0112
var ANALOG_INPUTS_CHANGE_FILTER = 5;// Default = ~5mV - this is the amount of change in the raw value we look at before we send socket update
var ANALOG_INPUTS_FIRST_READ = true;// Track the first read

//var TotalDuration = 0;
//var TotalReads = 0;

// These constants are for use as 
var ANALOG_INPUTS_IN_RANGE = 0;
var ANALOG_INPUTS_BELOW_THRESHOLD = 1;
var ANALOG_INPUTS_ABOVE_THRESHOLD = 2;
var ThresholdValues = ["NORMAL", "BELOW", "ABOVE"];

// Timing analysis    
var totalCycleTime = 0.0;
var averageCycleTime = 0.0;
var totalCycles = 0;
var analogInputsReadStart;
var AnalogInputPointsRead = 0;

// The following array holds, in memory, the current value (in raw bit values - 0 to 2500)
var analogInputsArray = [
    { "Address" : "0", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "1", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "2", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "3", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "4", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "5", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "6", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "7", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 

    { "Address" : "8", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "9", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "10", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "11", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "12", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "13", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "14", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "15", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 

    { "Address" : "16", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "17", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "18", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "19", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "20", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "21", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "22", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "23", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 

    { "Address" : "24", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "25", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "26", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "27", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "28", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "29", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "30", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }, 
    { "Address" : "31", "Name" : "Name", "FormulaId" : 0, "FormulaEnabled" : 1, "RawValue": 0, "RangedValue": 0 , "FormulaValue": 0, "ThresholdState": ANALOG_INPUTS_IN_RANGE, "TempValue": 0, "HoldTimerActive": false, "HoldTimer": 0, "Enabled": "FALSE", "SendEvents": "FALSE" , "Range": ANALOG_INPUTS_MAXIMUM_RANGE, "LowThreshold": 0, "HighThreshold": 0, "FormulaLowThreshold": 0, "FormulaHighThreshold": 0, "Offset": 0, "HoldTime": 0, "Qualifier": 0, "QualifierValue": 0, "TimeChanged": 0 }
];

// Requires
var fs = require('fs');
var moment = require('moment');
var SmtpManager = [];

var _this = this;// To allow access to exported functions

//#endregion Analog Inputs Constants, Globals and Requires

//#region Analog Inputs Initialize and Update
// Initialize the analog inputs upon system start
//      - Checks if database table exists, if not creates the table and fills it with default data for each point
//      - Else reads from the database and updates analogInputsArray
exports.InitializeAnalogInputs = function (smtp, db, io, logger, callback) {
    // Initialize SmtpManager
    SmtpManager = smtp;
    
    // Try getting the AnalogInputs table
    db.get("SELECT name FROM sqlite_master WHERE type='table' AND name='AnalogInputs'", function (err, rows) {
        if (err !== null) {
            logger.error('Analog Inputs - Initialize Error (Check)=' + JSON.stringify(err));
        }
        else if (rows === undefined) {
            // We read nothing, so let's create the table ...
            logger.info("Analog Inputs - Initialize by creating database table ...");
            db.exec("CREATE TABLE if not exists AnalogInputs (Address INTEGER, Name TEXT, FormulaId INTEGER, FormulaEnabled INTEGER, RawValue INTEGER, RangedValue TEXT, ThresholdState INTEGER, Enabled TEXT, SendEvents TEXT, Range TEXT, LowThreshold TEXT, HighThreshold TEXT, Offset TEXT, HoldTime INTEGER, Qualifier INTEGER, TimeChanged TEXT )", function (err) {
                if (err !== null) {
                    logger.error('Analog Inputs - Initialize Error (Create)=' + JSON.stringify(err));
                }
                else {
                    var timeChanged = moment();// Record the create time as the last time the I/O point value was changed
                    
                    // Created the table, now add data ...
                    db.run("BEGIN")
                    for (var i = 0; i < (ANALOG_INPUTS_CHIPS_PER_BOARD * ANALOG_INPUTS_POINTS_PER_CHIP); i++) {
                        // Initialize the array
                        UpdateAnalogInputConfiguration(i, "Analog Input " + (i + 1), -1, 1, 0, 0, 0, 0, "FALSE", "FALSE", ANALOG_INPUTS_MAXIMUM_RANGE, ANALOG_INPUTS_DEFAULT_LOW_THRESHOLD, ANALOG_INPUTS_DEFAULT_HIGH_THRESHOLD, 0, 0, 0, 0, 0, timeChanged, io, logger);
                        analogInputsArray[i].RawValue = -1;// Force a new read
                        analogInputsArray[i].TempValue = -1;// Historical NOT USED anymore
                        analogInputsArray[i].HoldTimerActive = false;
                        analogInputsArray[i].HoldTimer = timeChanged;
                        
                        // Initialize the database
                        insertStatement = i + ", 'Analog Input " + (i + 1) + "', -1, 1, 0, '0', 0, 'FALSE', 'FALSE', '" + ANALOG_INPUTS_MAXIMUM_RANGE + "', '" + ANALOG_INPUTS_DEFAULT_LOW_THRESHOLD + "', '" + ANALOG_INPUTS_DEFAULT_HIGH_THRESHOLD + "', '0', 0, 0, '" + timeChanged + "'";
                        //logger.debug('INSERT INTO AnalogInputs (Address, Name, FormulaId, FormulaEnabled, RawValue, RangedValue, FormulaValue, Enabled, SendEvents, Range, LowThreshold, HighThreshold, FormulaLowThreshold, FormulaHighThreshold, Offset, HoldTime, Qualifier, TimeChanged) VALUES (' + insertStatement + ');');
                        db.run('INSERT INTO AnalogInputs (Address, Name, FormulaId, FormulaEnabled, RawValue, RangedValue, ThresholdState, Enabled, SendEvents, Range, LowThreshold, HighThreshold, Offset, HoldTime, Qualifier, TimeChanged) VALUES (' + insertStatement + ');', function (err) {
                            if (err !== null) {
                                logger.error('Analog Inputs - Initialize Error (Insert)=' + JSON.stringify(err));
                            }
                        });
                    }
                    db.run("COMMIT");
                    
                    // Analog Inputs table created
                    if (typeof callback == "function") {
                        logger.info('Analog Inputs - Initialized new database table');
                        callback();
                    }
                }
            });
        }
        else {
            // Write out current AnalogInputs table
            logger.info("Analog Inputs - Initialize by reading database ...");
            db.each("SELECT rowid as id, Address, Name, FormulaId, FormulaEnabled, RawValue, RangedValue, ThresholdState, Enabled, SendEvents, Range, LowThreshold, HighThreshold, Offset, HoldTime, Qualifier, TimeChanged FROM AnalogInputs ORDER BY Address", function (err, row) {
                if (err !== null) {
                    logger.error('Analog Inputs - Initialize Error (Select)=' + JSON.stringify(err));
                }
                else {
                    row.RawValue = -1;// Force a new value read on startup
                    row.ThresholdState = -1;// Force an evaluation of threshold on startup
                    UpdateAnalogInputConfiguration(row.Address, row.Name, row.FormulaId, row.FormulaEnabled, row.RawValue, row.RangedValue, 0, row.ThresholdState, row.Enabled, row.SendEvents, row.Range, row.LowThreshold, row.HighThreshold, 0, 0, row.Offset, row.HoldTime, row.Qualifier, row.TimeChanged, io, logger)
                    logger.debug("Analog Inputs - [Value INITIAL from dB] Analog Input[" + (parseInt(row.Address) + 1) + "] '" + row.Name + "' RawValue=" + row.RawValue);
                }
            }, function () {
                // Analog Inputs read from table
                if (typeof callback == "function") {
                    logger.info('Analog Inputs - Initialized from existing database table');
                    callback();
                }
            });
        }
    });
}

// Adjust the analogInputsArray
//  This is only called during initialization of the dB and if the client makes a change
module.exports.UpdateAnalogInputConfiguration = UpdateAnalogInputConfiguration;
function UpdateAnalogInputConfiguration(Address, Name, FormulaId, FormulaEnabled, RawValue, RangedValue, FormulaValue, ThresholdState, Enabled, SendEvents, Range, LowThreshold, HighThreshold, FormulaLowThreshold, FormulaHighThreshold, Offset, HoldTime, Qualifier, TimeChanged, io, logger) {
    
    analogInputsArray[Address].Name = Name;
    analogInputsArray[Address].FormulaId = FormulaId;
    analogInputsArray[Address].FormulaEnabled = FormulaEnabled;
    analogInputsArray[Address].RawValue = RawValue;
    analogInputsArray[Address].FormulaValue = FormulaValue;
    analogInputsArray[Address].RangedValue = RangedValue;
    analogInputsArray[Address].ThresholdState = ThresholdState;
    analogInputsArray[Address].Enabled = Enabled;
    analogInputsArray[Address].SendEvents = SendEvents;
    analogInputsArray[Address].Range = Range;
    analogInputsArray[Address].LowThreshold = LowThreshold;
    analogInputsArray[Address].HighThreshold = HighThreshold;
    analogInputsArray[Address].Offset = Offset;
    analogInputsArray[Address].HoldTime = HoldTime;
    analogInputsArray[Address].Qualifier = Qualifier;
    analogInputsArray[Address].QualifierValue = 0;
    analogInputsArray[Address].TempValue = -1;// Set to last known RawValue, will be fixed by first read
    analogInputsArray[Address].TimeChanged = TimeChanged;
    
    // Update FormulaValue, FormulaLowThreshold, FormulaHighThreshold info, if present
    var FormulaIndex = -1;
    if (analogInputsArray[Address].FormulaId !== -1) {
        //logger.info("UpdateAnalogInputConfiguration - Address=" + Address + " has a FormulaID=" + analogInputsArray[Address].FormulaId);
        // Find formula
        //logger.info("UpdateAnalogInputConfiguration - FormulasArray[" + f + "].length=" + FormulasArray.length);
        for (var f = 0; f < FormulasArray.length; f++) {
            if (analogInputsArray[Address].FormulaId === FormulasArray[f].Id) {
                FormulaIndex = f;
                break;
            }
        }
        //logger.info("UpdateAnalogInputConfiguration - FormulaIndex=" + FormulaIndex);
        
        // Check to see if have a formula, if not don't worry about FormulaValue for this change
        if (FormulaIndex !== -1) {
            analogInputsArray[Address].FormulaValue = _this.CalculateFormula(analogInputsArray[Address].RangedValue, FormulasArray[FormulaIndex], logger);
            //logger.info("UpdateAnalogInputConfiguration - Calculating RangedValue=" + analogInputsArray[Address].RangedValue + " -> FormulaValue=" + analogInputsArray[Address].FormulaValue);
            analogInputsArray[Address].FormulaLowThreshold = _this.CalculateFormula(analogInputsArray[Address].LowThreshold, FormulasArray[FormulaIndex], logger);
            //logger.info("UpdateAnalogInputConfiguration - Calculating LowThreshold=" + analogInputsArray[Address].LowThreshold + " -> FormulaLowThreshold=" + analogInputsArray[Address].FormulaLowThreshold);
            analogInputsArray[Address].FormulaHighThreshold = _this.CalculateFormula(analogInputsArray[Address].HighThreshold, FormulasArray[FormulaIndex], logger);
            //logger.info("UpdateAnalogInputConfiguration - Calculating HighThreshold=" + analogInputsArray[Address].HighThreshold + " -> FormulaHighThreshold=" + analogInputsArray[Address].FormulaHighThreshold);
        }
    } else {
        // Update based on what was sent in
        analogInputsArray[Address].FormulaValue = FormulaValue;
        analogInputsArray[Address].FormulaLowThreshold = FormulaLowThreshold;
        analogInputsArray[Address].FormulaHighThreshold = FormulaHighThreshold;
    }
    
    //logger.info("UpdateAnalogInputConfiguration - FormulaValue=" + analogInputsArray[Address].FormulaValue);
    //logger.info("UpdateAnalogInputConfiguration - FormulaLowThreshold=" + analogInputsArray[Address].FormulaLowThreshold);
    //logger.info("UpdateAnalogInputConfiguration - FormulaHighThreshold=" + analogInputsArray[Address].FormulaHighThreshold)
    
    logger.debug("UpdateAnalogInputConfiguration - analogInputsArray[" + (Address + 1) + "]=" + JSON.stringify(analogInputsArray[Address]));
    
    sendValueAnalogInputs(io, logger);// Update the Analog Inputs configuration
}
//#endregion Analog Inputs Initialize and Update

//#region Analog Inputs Utility Methods

module.exports.GetAnalogInputValues = GetAnalogInputValues;
function GetAnalogInputValues(address, logger) {
    //logger.debug("GetAnalogInputValues - address=" + address + " values=" + JSON.stringify(analogInputsArray[address]));
    return analogInputsArray[address];
}

function ConvertRawValueToValue(rawValue, logger) {
    value = Number(parseFloat(rawValue) * ANALOG_INPUTS_RAWVALUE_SLOPE + ANALOG_INPUTS_RAWVALUE_OFFSET);
    if (value < 0) value = 0;
    return value;
}

function ConvertValueToRawValue(value, logger) {
    rawValue = Math.round((parseFloat(value) - ANALOG_INPUTS_RAWVALUE_OFFSET) / ANALOG_INPUTS_RAWVALUE_SLOPE);
    //logger.trace("ConvertValueToRawVaule: value=" + value + "  rawValue=" + rawValue);
    return rawValue;
}

module.exports.UpdateQualifierValues = UpdateQualifierValues;
function UpdateQualifierValues(digitalInputsArray, db, logger, io) {
    for (qualifier = 0; qualifier < digitalInputsArray.length; qualifier++) {
        for (analogInput = 0; analogInput < analogInputsArray.length ; analogInput++) {
            if (analogInputsArray[analogInput].Qualifier > 0) {
                // This analog has a qualifier defined, so let's update the current qualifier value
                if ((analogInputsArray[analogInput].Qualifier - 1) == qualifier) {
                    if (analogInputsArray[analogInput].QualifierValue != digitalInputsArray[qualifier].Value) {
                        logger.info("Analog Inputs - [REAL-TIME UPDATE(Config) - Qualifier Changed] Analog Input[" + (analogInput + 1) + "] Qualifier='" + digitalInputsArray[qualifier].Name + "' Value=" + digitalInputsArray[qualifier].Value);
                        sendValueAnalogInput("AnalogInput", analogInputsArray[analogInput], io, logger);// Send updated qualifier value
                        if (digitalInputsArray[qualifier].Value == 1)
                            io.sockets.emit("AnalogInputQualifier", { "AnalogInput": analogInput, "Qualifier": true });
                        else
                            io.sockets.emit("AnalogInputQualifier", { "AnalogInput": analogInput, "Qualifier": false });
                    }
                    analogInputsArray[analogInput].QualifierValue = digitalInputsArray[qualifier].Value;
                }
            }
        }
    }
}

module.exports.getAnalogInputCurrentValue = getAnalogInputCurrentValue;
function getAnalogInputCurrentValue(address, logger) {
    //logger.debug("getAnalogInputCurrentValue - address=" + address + " value=" + analogInputsArray[address].RawValue);
    return analogInputsArray[address].RawValue;
}

module.exports.getAnalogInputQualifierValue = getAnalogInputQualifierValue;
function getAnalogInputQualifierValue(address, logger) {
    return analogInputsArray[address].QualifierValue;
}

module.exports.getAnalogInputThresholdState = getAnalogInputThresholdState;
function getAnalogInputThresholdState(AnalogInput, Value, logger) {
    var LowThresholdRawValue = ConvertValueToRawValue(AnalogInput.LowThreshold, logger);
    var HighThresholdRawValue = ConvertValueToRawValue(AnalogInput.HighThreshold, logger);
    var CurrentRangedValue = ConvertRawValueToValue(Value, logger);
    
    var ThresholdState = ANALOG_INPUTS_IN_RANGE;
    if (Value < LowThresholdRawValue) {
        // This specifically tests for the 0.00V case
        if (AnalogInput.LowThreshold != CurrentRangedValue) {
            ThresholdState = ANALOG_INPUTS_BELOW_THRESHOLD
        } else {
            //logger.info("Analog Inputs - [NO THRESHOLD CHANGE] Analog Input[" + AnalogInput.Address + "] LowThreshold=" + AnalogInput.LowThreshold + " Value=" + CurrentRangedValue);
        }
    } else if (Value > HighThresholdRawValue) {
        ThresholdState = ANALOG_INPUTS_ABOVE_THRESHOLD
    }
    
    return ThresholdState;
}

//#endregion Analog Inputs Utility Methods

//#region Analog Inputs Processing
// Intervalled processing of analog inputs
var processCounter = 0;
var processTotalTime = 0;
var startAnalogInputReadTime = 0;
var counterAnalogInputReadTime = 0;
var totalAnalogInputReadTime = 0;

// These variable hand interim real-time updates
var LastTimeBeforeInterimUpdate = moment();
var CurrentTimeBeforeInterimUpdate;
var SendInterimUpdate = false;
var ANALOGINPUTS_INTERIM_UPDATE = ANALOG_INPUTS_CYCLE_TIME * 10;

exports.ProcessAnalogInputs = function (db, logger, io, netSnmp, ledManager) {
    
    //var timeStart = moment();
    //logger.info("ProcessAnalogInputs called at "+moment().format("hh:mm:ss.SSS"))
    
    // Code to measure time between Analog I/O process calls
    //#region Analog I/O Read Cycle Process Calls
    //totalAnalogInputReadTime += timeStart - startAnalogInputReadTime;//How much time has elapsed since last time we were here
    //counterAnalogInputReadTime++;
    //startAnalogInputReadTime = timeStart;// Last time we started
    //if (counterAnalogInputReadTime === 10) {
    //    logger.info("ProcessAnalogInputs: Average time between call= " + (totalAnalogInputReadTime / counterAnalogInputReadTime).toFixed(2) + "msec");
    //    totalAnalogInputReadTime = 0;
    //    counterAnalogInputReadTime = 0;
    //}
    //#endregion Analog I/O Read Cycle Process Calls
    
    if (ANALOG_INPUTS_FIRST_READ) {
        logger.trace("Analog Inputs - Starting processing at " + ANALOG_INPUTS_RATE + "ms/point");
    }
    
    var count = 0;
    var index = 0;
    AnalogInputPointsRead = 0;
    var chipCounter = 0;
    var inputCounter = 0;

    var analoginputloop = setInterval(function () {
        readAnalogInputFile(chipCounter, inputCounter, db, io, logger, netSnmp)
        inputCounter++
        if (inputCounter == ANALOG_INPUTS_POINTS_PER_CHIP) {
            inputCounter = 0;
            chipCounter++;
            if (chipCounter == ANALOG_INPUTS_CHIPS_PER_BOARD) {
                clearInterval(analoginputloop);// We're done
                ANALOG_INPUTS_FIRST_READ = false;
                
                // To do a 5second real-time update, in case they've refreshed the screen
                CurrentTimeBeforeInterimUpdate = moment();
                if ((CurrentTimeBeforeInterimUpdate - LastTimeBeforeInterimUpdate) > ANALOGINPUTS_INTERIM_UPDATE) {
                    SendInterimUpdate = true;
                    LastTimeBeforeInterimUpdate = CurrentTimeBeforeInterimUpdate;
                } else {
                    SendInterimUpdate = false;
                }
            }
        }
    }, ANALOG_INPUTS_RATE);
    
    //for (var chipCounter = 0; chipCounter < ANALOG_INPUTS_CHIPS_PER_BOARD ; chipCounter++) {
    //    for (var inputCounter = 0; inputCounter < ANALOG_INPUTS_POINTS_PER_CHIP; inputCounter++) {
    //        readAnalogInputFile(chipCounter, inputCounter, db, io, logger, netSnmp)
    //    }
    //}

    // Code to measure complete analog I/O read cycle
    //#region Complete Analog I/O Read Cycle
    //if (processCounter === 10) {
    //    logger.info("ProcessAnalogInputs: Average process time = " + (processTotalTime / processCounter).toFixed(2) + "msec");
    //    processCounter = 0;
    //    processTotalTime = 0;
    //}
    //processCounter++;
    //processTotalTime += (moment() - timeStart);
    //#endregion Complete Analog I/O Read Cycle
}

function readAnalogInputFile(chipCounter, inputCounter, db, io, logger, netSnmp) {
    var index = inputCounter + ANALOG_INPUTS_POINTS_PER_CHIP * chipCounter;
    var timeChanged = moment();
    
    //logger.info("Reading File: " + ANALOG_INPUTS_LOCATION + "/hwmon" + chipCounter + "/in" + inputCounter + "_input - Analog Input[" + index + "].Enabled=" + analogInputsArray[index].Enabled);
    
    // Only read value if the I/O point is enabled
    if (analogInputsArray[index].Enabled === "TRUE") {
        try {
            //timeStart = moment();
            var readValue = 0;
            var data = 0;
            try {
                data = fs.readFileSync(ANALOG_INPUTS_LOCATION + "/hwmon" + chipCounter + "/in" + inputCounter + "_input", 'utf8');
            } catch (err) {
                // This is to catch infrequent errors related to reading
                logger.error('Analog Inputs - Process Error (File Read): error=' + err + ' (Analog Input[' + (index + 1) + '] @ Location: Chip=' + chipCounter + ', Input=' + inputCounter + ')');
                return;
            }
            
            // Get rid of any offending extra characters in read
            readValue = String(data).replace(/(\r\n|\n|\r|[ +])/img, "");
            //logger.info("Read    File: " + ANALOG_INPUTS_LOCATION + "/hwmon" + chipCounter + "/in" + inputCounter + "_input - readValue=" + readValue);
            //logger.trace('Analog Inputs - Process OK (File Read)= Normal (Analog Input at Address=' + index + ' readValue=' + readValue + ') - Stored RawValue=' + analogInputsArray[index].RawValue);
           
            
            // Add the offset to the read value
            readValue = Math.round(Number(readValue) + Number(ConvertValueToRawValue(analogInputsArray[index].Offset, logger)) - Number(ConvertValueToRawValue(0, logger)));
            
            // Create temp value to track allow us to handle hold times & qualifiers
            tempAnalogInputPoint = JSON.parse(JSON.stringify(analogInputsArray[index]));
            tempAnalogInputPoint.RawValue = readValue;
            tempAnalogInputPoint.RangedValue = ConvertRawValueToValue(readValue, logger);
            
            // Filter logic
            //  - We ignore minute changes in the analog values, 
            //    change in raw value must be greater than ANALOG_INPUTS_CHANGE_FILTER
            //  - But we need to go through the logic when a HoldTimer is being used
            //#region Filter logic
            // Don't do anything if:
            //  - there has been no change in the raw value reading (so there's no real change in the input)
            //  - there is no hold time (so we don't have to start any timers)
            //  - the threshold state is valid (it hasn't been invalidated because of a configuration change)
            var valueChanged = Math.abs(analogInputsArray[index].RawValue - readValue);
            if ((valueChanged <= ANALOG_INPUTS_CHANGE_FILTER) 
                && (analogInputsArray[index].HoldTime == 0) 
                && (analogInputsArray[index].ThresholdState >= 0)
                && !SendInterimUpdate) {                
                return;
            }

            //if (valueChanged > ANALOG_INPUTS_CHANGE_FILTER) logger.info("Value Changed: " + ANALOG_INPUTS_LOCATION + "/hwmon" + chipCounter + "/in" + inputCounter + "_input - readValue=" + readValue + " previous RawValue=" + analogInputsArray[index].RawValue + " valueChanged=" + valueChanged);

            if (analogInputsArray[index].HoldTime > 0) {
                logger.trace("Analog Inputs - [Filter: HoldTimer Used] Analog Input[" + (index + 1) + "] old value[array]=" + analogInputsArray[index].RawValue + " new value[read]=" + readValue);
            } else {
                logger.trace("Analog Inputs - [Filter: Value Changed] Analog Input[" + (index + 1) + "] old value[array]=" + analogInputsArray[index].RawValue + " new value[read]=" + readValue);
            }
            //#endregion Filter logic
            
            // Threshold Change logic
            //  - ThresholdChanged = true or false, depending if we've changed a threshold
            //#region Threshold logic
            var ThresholdChanged = false;
            var oldThreshold = analogInputsArray[index].ThresholdState;
            var newThreshold = getAnalogInputThresholdState(tempAnalogInputPoint, tempAnalogInputPoint.RawValue, logger);
            if ((oldThreshold != newThreshold) || (oldThreshold < 0)) {
                ThresholdChanged = true;
                logger.trace("Analog Inputs - [Threshold=" + ThresholdChanged + "] Analog Input[" + (index + 1) + "] Stored=" + analogInputsArray[index].RangedValue + "V (" + (oldThreshold != -1?ThresholdValues[oldThreshold]:"UNDEFINED") + "),  RealTime=" + tempAnalogInputPoint.RangedValue.toFixed(2) + "V (" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED") + ")");
            } else {
                logger.trace("Analog Inputs - [Threshold=" + ThresholdChanged + "] Analog Input[" + (index + 1) + "] Stored=" + analogInputsArray[index].RangedValue + "V (" + (oldThreshold != -1?ThresholdValues[oldThreshold]:"UNDEFINED") + "),  RealTime=" + tempAnalogInputPoint.RangedValue.toFixed(2) + "V (" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED") + ")");
            }
            //#endregion Threshold logic
            
            // Qualification logic
            //  - QualifierValid = true or false, depending if qualified by digital input
            //  - AnalogInput[index].HoldTimerActive = true or false, depending on qualifications status
            //  - AnalogInput[index].HoldTimer = holds time of when first qualified, with or without qualifier
            //#region Qualification logic
            var QualifierValid = false;
            
            if (analogInputsArray[index].Qualifier > 0) {
                // Qualifier USED logic
                //#region Qualifier USED logic
                if (analogInputsArray[index].QualifierValue > 0) {
                    //#region HoldTime logic for Qualifier USED & TRUE
                    QualifierValid = true;
                    //logger.trace("Analog Inputs - [Qualifier=USED, QualifierValid=TRUE] Analog Input[" + (index+1) + "] using qualifier=DigitalInput[" + (analogInputsArray[index].Qualifier) + "]");

                    if (analogInputsArray[index].HoldTime > 0) {
                        // If there is a hold time ...
                        if (analogInputsArray[index].HoldTimerActive === false) {
                            // If the hold timer was previously not running ...
                            if (ThresholdChanged) {
                                //  And the threshold changed ... start the timer
                                analogInputsArray[index].HoldTimer = timeChanged;
                                analogInputsArray[index].HoldTimerActive = true;
                                logger.info("Analog Inputs - [HOLD TIMER - HoldTimer=" + (analogInputsArray[index].HoldTime > 0?"STARTED (Threshold Change)":"NOT_USED") + "Qualifier=USED, QualifierValid=TRUE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' using qualifier=DigitalInput[" + (analogInputsArray[index].Qualifier) + "]");
                                io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "HOLDING" })
                            }
                        } 
                        else {
                            // If the hold timer was previously running ...
                            if (!ThresholdChanged) {
                                // If the threshold changed ...
                                if (analogInputsArray[index].HoldTimerActive == true) {
                                    //  And the threshold has returned to same place ... reset the timer
                                    logger.info("Analog Inputs - [HOLD TIMER - HoldTimer=" + (analogInputsArray[index].HoldTime > 0?"RESET (Threshold Return)":"NOT_USED") + ", Qualifier=USED, QualifierValid=TRUE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' using qualifier=DigitalInput[" + (analogInputsArray[index].Qualifier) + "]");
                                    io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "OFF" })
                                    analogInputsArray[index].HoldTimerActive = false;
                                }
                            }
                        }
                    }
                    //#endregion HoldTime logic for Qualifier USED & TRUE
                } else {
                    //#region HoldTime logic for Qualifier USED & FALSE
                    QualifierValid = false;
                    //logger.trace("Analog Inputs - [Qualifier=USED, QualifierValid=FALSE] Analog Input[" + (index+1) + "] using qualifier=DigitalInput[" + (analogInputsArray[index].Qualifier) + "]");

                    if (analogInputsArray[index].HoldTime > 0) {
                        // If there is a hold time ...
                        if (analogInputsArray[index].HoldTimerActive == true) {
                            // Reset hold timer ... it will have to be requalified
                            logger.info("Analog Inputs - [HOLD TIMER - HoldTimer=" + (analogInputsArray[index].HoldTime > 0?"RESET (Qualifier Failed)":"NOT_USED") + ", Qualifier=USED, QualifierValid=FALSE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' using qualifier=DigitalInput[" + (analogInputsArray[index].Qualifier) + "]");
                            io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "OFF" })
                            analogInputsArray[index].HoldTimerActive = false;
                        }
                    }
                    //#endregion HoldTime logic for Qualifier USED & FALSE
                }
                //#endregion Qualifier USED logic
            } else {
                // Qualifier NOT USED logic
                //#region Qualifier NOT USED logic
                //#region HoldTime logic for QUALIFIER NOT USED
                QualifierValid = true;
                //logger.trace("Analog Inputs - [Qualifier=NOT_USED] Analog Input[" + (index+1) + "]");

                if (analogInputsArray[index].HoldTime > 0) {
                    // If there is a hold time ...
                    if (analogInputsArray[index].HoldTimerActive === false) {
                        // If the hold timer was previously not running ...
                        if (ThresholdChanged) {
                            //  And there was a threshold change ... start the timer
                            analogInputsArray[index].HoldTimer = timeChanged;
                            analogInputsArray[index].HoldTimerActive = true;
                            logger.debug("Analog Inputs - [HOLD TIMER - HoldTimer=" + (analogInputsArray[index].HoldTime > 0?"STARTED (Threshold Change)":"NOT_USED") + ", Qualifier=NOT_USED] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "'");
                            io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "HOLDING" })
                        }
                    }
                    else {
                        //  And the threshold has returned to same place ... reset the timer
                        // If the hold timer was previously running ...
                        if (!ThresholdChanged) {
                            if (analogInputsArray[index].HoldTimerActive == true) {
                                logger.debug("Analog Inputs - [HOLD TIMER - HoldTimer=" + (analogInputsArray[index].HoldTime > 0?"RESET (Threshold Return)":"NOT_USED") + ", Qualifier=NOT_USED] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "'");
                                io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "OFF" })
                                analogInputsArray[index].HoldTimerActive = false;
                            }
                        }
                    }
                }
                //#endregion HoldTime logic for QUALIFIER NOT USED
                //#endregion Qualifier NOT USED logic
            }
            //#endregion Qualification logic
            
            // HoldTime logic
            //  - HoldTimeValid = true or false, depending on:
            //      - true: if holdtimer is used & >= holdtime
            //      - true: if holdtimer is not used
            //      - false: all other conditions
            //#region HoldTime logic
            var HoldTimeValid = false;
            var HoldTimeChanged = 0;
            var HoldTimeActive = false;
            if (analogInputsArray[index].HoldTime > 0) {
                // Using a hold time ...
                if (analogInputsArray[index].HoldTimerActive == true) {
                    // Hold time is valid ...
                    HoldTimeActive = true;
                    HoldTimeChanged = (timeChanged - analogInputsArray[index].HoldTimer) / 1000;
                    if (HoldTimeChanged >= analogInputsArray[index].HoldTime) {
                        HoldTimeValid = true;
                        logger.info("Analog Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(analogInputsArray[index].HoldTime).toFixed(2) + "s, Timer=" + parseFloat(HoldTimeChanged).toFixed(2) + "s, HoldTimeValid=TRUE] Analog Input[" + (index+ 1) + "] '" + analogInputsArray[index].Name + "'");
                        // Turn on, then turn off Hold Time button
                        io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "ON" });
                        (function (index) {
                            setTimeout(function () {
                                io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "OFF" })
                            }, 1000);
                        })(index);
                    } else {
                        logger.info("Analog Inputs - [HOLD TIMER - HoldTimer=" + parseFloat(analogInputsArray[index].HoldTime).toFixed(2) + "s, Timer=" + parseFloat(HoldTimeChanged).toFixed(2) + "s, HoldTimeValid=FALSE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "'");
                        io.sockets.emit("AnalogInputHoldTime", { "AnalogInput": index, "HoldTime": "HOLDING" })
                    }
                }
            } else {
                // Not using a hold time ...
                HoleTimeActive = false;
                HoldTimeValid = true;
                logger.trace("Analog Inputs - [HOLD TIMER - HoldTimer=NOT_USED] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "'");
            }
            //#endregion HoldTime logic
            
            // Publish logic (real-time info and SNMP traps)
            //  Refer to the 'Crest - Real-time updates and SNMP traps.xlsx' document for cases
            //#region Publish logic
            var FormulaIndex;
            if (QualifierValid && HoldTimeValid) {
                // If the change is qualified and holdtime is valid ...
                //#region QualifierValid=TRUE and HoldTimeValid=TRUE preamble
                // Update the local array to the new values
                
                // Calculate Formula info, if present
                analogInputsArray[index].RawValue = readValue;
                analogInputsArray[index].RangedValue = ConvertRawValueToValue(analogInputsArray[index].RawValue, logger).toFixed(2);// Update the Ranged Value
                //#region Calculate FormulaValue
                FormulaIndex = -1;
                if (analogInputsArray[index].FormulaId !== -1) {
                    // Find formula
                    for (var f = 0; f < FormulasArray.length; f++) {
                        if (analogInputsArray[index].FormulaId === FormulasArray[f].Id) {
                            FormulaIndex = f;
                            break;
                        }
                    }
                    
                    // Check to see if have a formula, if not don't worry about FormulaValue for this change
                    if (FormulaIndex !== -1) {
                        analogInputsArray[index].FormulaValue = _this.CalculateFormula(analogInputsArray[index].RangedValue, FormulasArray[FormulaIndex], logger);
                    }
                }
                //#endregion Calculate FormulaValue
                //#endregion QualifierValid=TRUE and HoldTimeValid=TRUE preamble
                
                if (ThresholdChanged) {
                    // Threshold change is qualified and hold time is valid, so record the changes
                    //  *** CASE 1 : QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                    //  *** CASE 2B: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                    //  *** CASE 3A: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                    //  *** CASE 4D: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                    //#region QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                    analogInputsArray[index].TimeChanged = timeChanged;
                    analogInputsArray[index].ThresholdState = newThreshold;
                    analogInputsArray[index].HoldTimerActive = false;// If the threshold change, set HoldTimerState back to false to restart HoldTimer
                    
                    // Update real-time value, including SNMP because of threshold change
                    //  If this is the first time through, only report out of normal values
                    //  All other times report any changes
                    if ((ANALOG_INPUTS_FIRST_READ == false) || 
                        (ANALOG_INPUTS_FIRST_READ == true && analogInputsArray[index].ThresholdState != 0)) {
                        sendSocketSnmpSmtp(analogInputsArray[index], db, io, logger, netSnmp);                    
                    }
                    
                    // Record the analog input change in the database
                    db.run("UPDATE AnalogInputs SET RawValue='" + analogInputsArray[index].RawValue 
                    + "', RangedValue='" + analogInputsArray[index].RangedValue 
                    + "', TimeChanged='" + analogInputsArray[index].TimeChanged 
                    + "', ThresholdState='" + analogInputsArray[index].ThresholdState 
                    + "' WHERE Address = '" + index + "'", 
                    function () { });
                    
                    logger.info("Analog Inputs - [REAL-TIME UPDATE - Threshold Changed=TRUE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:"") + " Threshold=" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED") + " Qualifier=" + (analogInputsArray[index].Qualifier == 0?"NONE":"'Digital Input " + (analogInputsArray[index].Qualifier)) + "' HoldTime=" + (analogInputsArray[index].HoldTime == 0?"0":HoldTimeChanged.toFixed(2)) + "seconds");
                    logger.info("Analog Inputs - [THRESHOLD UPDATE - Threshold Changed=TRUE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:"") + " Threshold=" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED") + " Qualifier=" + (analogInputsArray[index].Qualifier == 0?"NONE":"'Digital Input " + (analogInputsArray[index].Qualifier)) + "' HoldTime=" + (analogInputsArray[index].HoldTime == 0?"0":HoldTimeChanged.toFixed(2)) + "seconds");
                    logger.debug("Analog Inputs - [DATABASE UPDATE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' New Value=" + analogInputsArray[index].RawValue + " New RangedValue=" + analogInputsArray[index].RangedValue + "V New ThresholdState=" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED"));
                    logger.trace("Analog Inputs - [DATABASE UPDATE] Analog Input[" + (index + 1) + "] =" + JSON.stringify(analogInputsArray[index]));
                    //#endregion QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=TRUE
                } else {
                    // No threshold changed, so just send real time update
                    //  *** CASE 1 : QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                    //  *** CASE 2B: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                    //  *** CASE 3A: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                    //  *** CASE 4D: QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                    //#region QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                    
                    // Update real-time value, if there was value change or we're holding
                    if (valueChanged > ANALOG_INPUTS_CHANGE_FILTER) {
                        logger.debug("Analog Inputs - [REAL-TIME UPDATE - Threshold Changed=FALSE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:""));
                        sendValueAnalogInput("AnalogInput", analogInputsArray[index], io, logger);
                    } 
                    else if (SendInterimUpdate) {
                        logger.trace("Analog Inputs - [REAL-TIME UPDATE(Interim) - Threshold Changed=FALSE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:""));
                        sendValueAnalogInput("AnalogInput", analogInputsArray[index], io, logger);
                    }
                    //#endregion QualifierValid=TRUE, HoldTimeValid=TRUE, ThresholdChange=FALSE
                }
            } else {
                
                // If we're qualified and changes are happening within the threshold value, send an update
                if (QualifierValid) {
                    // No threshold changed, so just send real time update
                    //  *** CASE 2A: QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=FALSE
                    //  *** CASE 2A: QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=TRUE
                    //  *** CASE 4C: QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=FALSE
                    //  *** CASE 4C: QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=TRUE
                    //#region QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=DONTCARE
                    analogInputsArray[index].RawValue = readValue;
                    analogInputsArray[index].RangedValue = ConvertRawValueToValue(analogInputsArray[index].RawValue, logger).toFixed(2);// Update the Ranged Value
                    
                    // Calculate Formula info, if present
                    //#region Calculate FormulaValue
                    FormulaIndex = -1;
                    if (analogInputsArray[index].FormulaId !== -1) {
                        // Find formula
                        for (var f = 0; f < FormulasArray.length; f++) {
                            if (analogInputsArray[index].FormulaId === FormulasArray[f].Id) {
                                FormulaIndex = f;
                                break;
                            }
                        }
                        
                        // Check to see if have a formula, if not don't worry about FormulaValue for this change
                        if (FormulaIndex !== -1) {
                            analogInputsArray[index].FormulaValue = _this.CalculateFormula(analogInputsArray[index].RangedValue, FormulasArray[FormulaIndex], logger);
                        }
                    }
                    //#endregion Calculate FormulaValue
                    
                    // Update real-time value, if there was value change or we're holding
                    if (valueChanged > ANALOG_INPUTS_CHANGE_FILTER) {
                        logger.info("Analog Inputs - [REAL-TIME UPDATE - QualifierValid=" + QualifierValid + ", HoldTimeValid=" + HoldTimeValid + "] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' ValueChanged=" + valueChanged + " RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:"") + " Threshold=" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED"));
                        sendValueAnalogInput("AnalogInput", analogInputsArray[index], io, logger);
                    } 
                    else if (SendInterimUpdate) {
                        // We won't clog up the log file with this during debug
                        logger.trace("Analog Inputs - [REAL-TIME UPDATE(Interim) - QualifierValid=" + QualifierValid + ", HoldTimeValid=" + HoldTimeValid + "] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "' ValueChanged=" + valueChanged + " RawValue=" + analogInputsArray[index].RawValue + " RangedValue=" + analogInputsArray[index].RangedValue + "V" + (FormulaIndex !== -1? " FormulaValue=" + analogInputsArray[index].FormulaValue + FormulasArray[FormulaIndex].Units:"") + " Threshold=" + (newThreshold != -1?ThresholdValues[newThreshold]:"UNDEFINED"));
                        sendValueAnalogInput("AnalogInput", analogInputsArray[index], io, logger);
                    }
                    //#endregion QualifierValid=TRUE, HoldTimeValid=FALSE, ValueChange=TRUE, ThresholdChange=DONTCARE
                } else {
                    // Not qualified, don't do anyting ...
                    logger.trace("Analog Inputs - [Qualifier=USED, QualifierValid=FALSE] Analog Input[" + (index + 1) + "] '" + analogInputsArray[index].Name + "'");
                }
            }
            //#endregion Publish logic
        }
        catch (error) {
            logger.error('Analog Inputs - Process Error (General)=' + error);
            logger.error('Analog Inputs - Address=' + (index + 1) + '  previousValue=' + analogInputsArray[index].RawValue + ' readValue=' + readValue);
        }
    }
    else {
    //logger.info("Analog Input[" + (index+1)) + "]= " + analogInputsArray[index].RawValue + " (Disabled)")
    }
}

// Use this function to force a read of the I/O
//  We need to do this after we change a configuration
//  We force both a read of the RawValue
//  160812: I took out calculation of ThresholdState so that we don't set off unncessary send out
//  This function basically forces a new evaulation, as a result socket and SNMP messages
module.exports.ForceNewRawValue = ForceNewRawValue;
function ForceNewRawValue(index, logger) {
    //logger.debug("ForceNewRawValue: For address index=" + index);
    analogInputsArray[index].RawValue = -1;
    analogInputsArray[index].ThresholdState = -1;// In case the threshold state was changed
}
//#endregion Analog Inputs Processing

//#region Analog Inputs Send and SNMP
// Initialize the snmpHostSessionsArray used for send SNMP messages
var SnmpHostSessionsArray = [];// Instance array for list of SNMP host sessions
exports.SetSnmpHostSessionsArray = function (snmpHostSessions, logger, callback) {
    SnmpHostSessionsArray = snmpHostSessions.slice(0);// Copy array
    logger.debug("Analog Inputs - Initialized SNMP Host Sessions");
    
    if (typeof callback == "function") {
        callback();
    }
}

function sendSocketSnmpSmtp(analogInput, db, io, logger, netSnmp) {
    // SNMP: Send SNMP Trap/Notification if threshold(s) crossed
    sendSNMP(analogInput, io, logger, netSnmp)
    
    // SOCKET.IO: Send changed value to all attached clients
    sendValueAnalogInput("AnalogInput", analogInput, io, logger);
    
    // SMTP: Send SMTP message if threshold(s) crossed
    sendSMTP(analogInput, io, logger)
}

function sendValueAnalogInput(dataType, data, io, logger) {
    //logger.info("sendValueAnalogInput - DataType='" + dataType + "' Analog Input[" + (data.Address+1) + "]=" + JSON.stringify(data));
    io.sockets.emit(dataType, data);
}

function sendValueAnalogInputs(io, logger) {
    enabled = 0;
    for (i = 0; i < analogInputsArray.length; i++) {
        if (analogInputsArray[i].Enabled === "TRUE") enabled++;
    }
    io.sockets.emit("AnalogInputs", { "AnalogInputsTotal": analogInputsArray.length, "AnalogInputsEnabled": enabled })
}

function sendSNMP(ioPoint, io, logger, netSnmp) {
    // SNMP definitions - also refer to the TASC-SUMMIT.MIB file for detailed information
    if (ioPoint.Enabled == "FALSE") return;
    if (ioPoint.SendEvents == "FALSE") return;
    
    
    address = parseInt(ioPoint.Address) + 1;// To overcome concatenation
    logger.trace("Analog Inputs - Sending SNMP Trap for Analog Input[" + address + "] '" + ioPoint.Name + "' Threshold=" + ioPoint.ThresholdState);
    
    // Calculate Formula info, if present
    var FormulaDefined = (ioPoint.FormulaId === -1) ? 0 : 1;// Integer
    var FormulaEnabled = (ioPoint.FormulaEnabled === 0) ? 0 : 1;// Integer
    var FormulaValue = "[N/A]";// Octet string - default=""
    var FormulaString = "[N/A]";// Octet string - default="[NONE]"
    var FormulaUnits = "[N/A]";// Octet string - default=""
    
    var FormulaIndex = -1;
    if (tempAnalogInputPoint.FormulaId !== -1) {
        // Find formula
        for (var f = 0; f < FormulasArray.length; f++) {
            if (tempAnalogInputPoint.FormulaId === FormulasArray[f].Id) {
                FormulaIndex = f;
                break;
            }
        }
        
        // If there is a formula for this I/O point, then extract the values
        if (FormulaIndex !== -1) {
            FormulaValue = ioPoint.FormulaValue; if (FormulaValue.length == 0) FormulaValue = "[Empty]";
            FormulaUnits = FormulasArray[FormulaIndex].Units; if (FormulaUnits.length == 0) FormulaUnits = "[Empty]";
            FormulaString = FormulasArray[FormulaIndex].Formula; if (FormulaString.length == 0) FormulaString = "[Empty]";
        }
    }
    //logger.debug("Analog Inputs - [SNMP Trap] FormulaDefined='" + FormulaDefined + "'");
    //logger.debug("Analog Inputs - [SNMP Trap] FormulaEnabled='" + FormulaEnabled + "'");
    //logger.debug("Analog Inputs - [SNMP Trap] FormulaValue='" + FormulaValue + "'");
    //logger.debug("Analog Inputs - [SNMP Trap] FormulaUnits='" + FormulaUnits + "'");
    //logger.debug("Analog Inputs - [SNMP Trap] FormulaString='" + FormulaString + "'");
    
    // Set up the SNMP trap    
    var trapOid = "1.3.6.1.4.1.11902.3.3.1000.1000.0." + (address - 1 + 1000);
    var varbinds = [
        {
            // Timestamp
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.1",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(moment().toString())
        },
        {
            // Address
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.2",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.Address) + 1
        },
        {
            // Name
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.3",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(ioPoint.Name)
        },
        {
            // RangedValue
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.4",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(((ConvertRawValueToValue(ioPoint.RawValue, logger)).toFixed(2)).toString())
        },
        {
            // ThresholdState
            //  ANALOG_INPUTS_IN_RANGE = 0
            //  ANALOG_INPUTS_BELOW_THRESHOLD = 1
            //  ANALOG_INPUTS_ABOVE_THRESHOLD = 2
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.5",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.ThresholdState)
        },
        {
            // LowThreshold
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.6",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(ioPoint.LowThreshold)
        },
        {
            // HighThreshold
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.7",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(ioPoint.HighThreshold)
        },
        {
            // Hold Time
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.8",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.HoldTime)
        },
        {
            // Offset (in 100mV)
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.9",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.Offset * 100)
        },
        {
            // Qualifier
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.10",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(ioPoint.Qualifier)
        },
        {
            // Formula Defined (1=TRUE, 0=FALSE)
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.11",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(FormulaDefined)
        },
        {
            // Formula Enabled (1=TRUE, 0=FALSE)
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.12",
            type: netSnmp.ObjectType.Integer,
            value: parseInt(FormulaEnabled)
        },
        {
            // Formula Value
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.13",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(FormulaValue)
        },
        {
            // Formula Units
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.14",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(FormulaUnits)
        },
        {
            // Formula 
            oid: "1.3.6.1.4.1.11902.3.3." + (address) + ".0.15",
            type: netSnmp.ObjectType.OctetString,
            value: new Buffer(FormulaString)
        }
    ];
    
    // Send the SNMP notification
    for (i = 0; i < SnmpHostSessionsArray.length; i++) {
        // Skip if this host is not enabled
        if (SnmpHostSessionsArray[i].Enabled === "FALSE") continue;
        
        // Send trap to host ...
        IPAddress = SnmpHostSessionsArray[i].Session.target;
        logger.debug("Analog Inputs - Sending to SNMP Host @ " + IPAddress + " - Analog Input[" + varbinds[1].value + "] '" + varbinds[2].value + "' Value=" + varbinds[4].value);
        SnmpHostSessionsArray[i].Session.trap(trapOid, varbinds, function (error) {
            if (error)
                logger.error("Analog Inputs - Send SNMP Error=" + error);
        });
    }
}

function sendSMTP(ioPoint, io, logger, netSnmp) {
    // SNMP definitions - also refer to the TASC-SUMMIT.MIB file for detailed information
    if (ioPoint.Enabled == "FALSE") return;
    if (ioPoint.SendEvents == "FALSE") return;
    
    // Calculate Formula info, if present
    var FormulaDefined = (ioPoint.FormulaId === -1) ? 0 : 1;// Integer
    var FormulaEnabled = (ioPoint.FormulaEnabled === 0) ? 0 : 1;// Integer
    var FormulaValue = "[N/A]";// Octet string - default=""
    var FormulaString = "[N/A]";// Octet string - default="[NONE]"
    var FormulaUnits = "[N/A]";// Octet string - default=""
    
    var FormulaIndex = -1;
    if (tempAnalogInputPoint.FormulaId !== -1) {
        // Find formula
        for (var f = 0; f < FormulasArray.length; f++) {
            if (tempAnalogInputPoint.FormulaId === FormulasArray[f].Id) {
                FormulaIndex = f;
                break;
            }
        }
        
        // If there is a formula for this I/O point, then extract the values
        if (FormulaIndex !== -1) {
            FormulaValue = ioPoint.FormulaValue; if (FormulaValue.length == 0) FormulaValue = "[Empty]";
            FormulaUnits = FormulasArray[FormulaIndex].Units; if (FormulaUnits.length == 0) FormulaUnits = "[Empty]";
            FormulaString = FormulasArray[FormulaIndex].Formula; if (FormulaString.length == 0) FormulaString = "[Empty]";
        }
    }
    
    // Set up the SMTP Email message
    var message = [];
    address = parseInt(ioPoint.Address) + 1;// To overcome concatenation
    var event = "'" + ioPoint.Name + "' has changed to status=" + ThresholdValues[ioPoint.ThresholdState] + " Value="+ (((ConvertRawValueToValue(ioPoint.RawValue, logger)).toFixed(2)).toString())+ "V";
    message += moment().toString() + "\n";
    message += "Address=" + (parseInt(ioPoint.Address) + 1) + "\n";
    message += "Name=" + ioPoint.Name + "\n";
    message += "Value=" + (((ConvertRawValueToValue(ioPoint.RawValue, logger)).toFixed(2)).toString()) + "\n";
    message += "Status=" + (ioPoint.ThresholdState) + "\n";
    message += "Low Threshold=" + (ioPoint.LowThreshold) + "\n";
    message += "High Threshold=" + (ioPoint.HighThreshold) + "\n";
    message += "Hold Time=" + parseInt(ioPoint.HoldTime) + "\n";
    message += "Offset=" + parseInt(ioPoint.Offset * 100) + "\n";
    message += "Qualifier=" + parseInt(ioPoint.Qualifier) + "\n";
    message += "Formula Defined=" + parseInt(FormulaDefined) + "\n";
    message += "Formula Enabled=" + parseInt(FormulaEnabled) + "\n";
    message += "Formula Value=" + FormulaValue + "\n";
    message += "Formula Units=" + FormulaUnits + "\n";
    message += "Formula=" + FormulaString + "\n";
    
    var ioInfo = "Analog Input[" + address + "] '" + ioPoint.Name + "'";
    
    logger.info("Analog Inputs - Sending SMTP Event for Analog Input[" + address + "] '" + ioPoint.Name + "'");
    SmtpManager.SendSmtp(message, ioInfo, event, function (result) {
        logger.trace("Analog Inputs - SMTP Email Event Response for Analog Input[" + address + "]: " + result.result);
    })
}

//#endregion Analog Inputs Send and SNMP

//#region Formulas Initialize and Udpate

var FormulasIo;
var FormulasDatabase;
var FormulasLogger;
var FormulasArray = [];

exports.InitializeFormulas = function (db, io, logger, callback) {
    
    // Set the globals
    FormulasDatabase = db;
    FormulasIo = io;
    FormulasLogger = logger;
    
    logger.info('Formulas.InitializeFormulas: Initializing formula database table');
    
    // Try getting the Formulas table
    db.get("SELECT name FROM sqlite_master WHERE type='table' AND name='Formulas'", function (err, rows) {
        if (err !== null) {
            logger.error('Formulas.InitializeFormulas - Initialize Error (Select)=' + JSON.stringify(err));
        }
        else if (rows === undefined) {
            // We read nothing, so let's create the table ...
            logger.info("Formulas.InitializeFormulas - Initialize by creating database table ...");
            db.exec("CREATE TABLE if not exists Formulas (Name TEXT, Formula TEXT, Units TEXT, Decimals INTEGER, TimeChanged TEXT )", function (err) {
                if (err !== null) {
                    logger.error('Formulas.InitializeFormulas - Initialize Error (Create)=' + JSON.stringify(err));
                }
                else {
                    if (typeof callback == "function") {
                        logger.info('Formulas.InitializeFormulas - Initialized new database table');
                        callback(FormulasArray);
                    }
                }
            });
        }
        else {
            // Read from the database and populate the Formulas array
            logger.info("Formulas.InitializeFormulas - Read Formulas from database ...");
            numberOfFormulas = 0;
            FormulasArray = [];
            db.each("SELECT rowid AS Id, Name, Formula, Units, Decimals, TimeChanged FROM Formulas", function (err, row) {
                if (err !== null) {
                    logger.error('Formulas.InitializeFormulas - Initialize Error (Select)=' + JSON.stringify(err));
                } else {
                    // Copy each row into Formulas array
                    logger.trace('Formulas.InitializeFormulas - Processing Host[' + (numberOfFormulas + 1) + ']=' + row.Name);
                    FormulasArray.push({
                        Id : row.Id,
                        Name : row.Name,
                        Formula : row.Formula,
                        Units: row.Units,
                        Decimals: row.Decimals,
                        TimeChanged : row.TimeChanged
                    });
                    logger.info("Formulas.InitializeFormulas - Read Formulas from Database[" + numberOfFormulas + "]=" + JSON.stringify(FormulasArray[numberOfFormulas]));
                    numberOfFormulas++;
                }
            }, function () {
                // Retrurn the complete list of Formulas
                logger.info('Formulas.InitializeFormulas - Initialized from existing database table');
                if (typeof callback == "function") {
                    callback(FormulasArray);
                }
            });
        }
    });
}

exports.UpdateFormulasPorts = function (formulas) {
    FormulasArray = formulas;
    console.log("Formulas.UpdateAccesControlPorts: formulas=" + JSON.stringify(formulas));
}

//#endregion Formulas Initialize and Update

//#region Formulas API Support

// Library to manage parsing and evaluation of math expressions within Crest formulas
var mathparser = require('node-expression-eval');

// Get Formulas
exports.GetFormulas = function (db, io, logger, callback) {
    
    // Get the FormulasArray by populating latest from database
    FormulasArray = [];
    db.all("SELECT rowid as Id, Name, Formula, Units, Decimals, TimeChanged FROM Formulas ORDER BY Id", function (err, rows) {
        if (err) {
            throw logger.error('Formulas.GetFormulas: SELECT users - Error (Read)=' + err);
        }
        
        // Repopulate AccessControlUsers array        
        FormulasArray = [];
        for (i = 0; i < rows.length; i++) {
            FormulasArray.push({
                "Id"            : rows[i].Id,
                "Name"          : rows[i].Name,
                "Formula"       : rows[i].Formula,
                "Units"         : rows[i].Units,
                "Decimals"      : rows[i].Decimals,
                "TimeChanged"   : rows[i].TimeChanged
            });
        }
        logger.debug('Formulas.GetFormulas: Users=' + JSON.stringify(FormulasArray));
        
        callback(FormulasArray);
    });
};

// Add Formula
exports.AddFormula = function (req, db, io, logger, callback) {
    
    // Add Formula
    var TimeChanged = moment();
    var dbcommand = "'" + req.body.Name + "', '" + req.body.Formula + "', '" + req.body.Units + "', " + req.body.Decimals + ", '" + TimeChanged + "'";
    logger.debug("Formulas.AddFormula: Add statement=" + dbcommand);
    logger.info("Formulas.AddFormula: Formula name=" + req.body.Name);
    db.run("INSERT INTO Formulas (Name, Formula, Units, Decimals, TimeChanged) VALUES (" + dbcommand + ")", function (err) {
        if (err !== null) {
            throw logger.error('Formulas.AddFormula: Formula=' + req.body.Name + ' - Error (Update)=' + JSON.stringify(err));
        }
        
        _this.GetFormulas(db, io, logger, function (FormulasArray) {
            callback(FormulasArray)
        });
    });
};

// Return FormulaValue
exports.getFormulaValue = function (Address, logger) {
    return analogInputsArray[Address].FormulaValue;
}

// Return FormulaLowThreshold
exports.getFormulaLowThreshold = function (Address, logger) {
    return analogInputsArray[Address].FormulaLowThreshold;
}

// Return FormulaHighThreshold
exports.getFormulaHighThreshold = function (Address, logger) {
    return analogInputsArray[Address].FormulaHighThreshold;
}

// Delete an existing Formula
exports.DeleteFormula = function (req, db, io, logger, callback) {
    
    // Delete Formula
    var dbcommand = "DELETE FROM Formulas WHERE rowid='" + req.body.Id + "'";
    logger.debug("Formulas.DeleteFormula: Delete statement=" + dbcommand);
    logger.info("Formulas.DeleteFormula: Formula name=" + req.body.Name);
    db.run(dbcommand, function (err) {
        if (err !== null) {
            throw logger.error('Formulas.DeleteFormula: User=' + req.params.formula + ' - Error (Update)=' + JSON.stringify(err));
        }
        
        _this.GetFormulas(db, io, logger, function (Formulas) {
            callback(Formulas)
        });
    });

};

// Modify an existing Formula
exports.ModifyFormula = function (req, db, io, logger, callback) {
    
    // Modify Formula
    var TimeChanged = moment();
    var dbcommand = "UPDATE Formulas SET Name='" + req.body.Name + "', Formula='" + req.body.Formula + "', Units='" + req.body.Units + "', Decimals=" + req.body.Decimals + ", TimeChanged='" + TimeChanged + "' WHERE rowid='" + req.body.Id + "'";
    logger.debug("Formulas.ModifyFormula: Modify statement=" + dbcommand);
    logger.info("Formulas.ModifyFormula: Formula name=" + req.body.Name);
    db.run(dbcommand, function (err) {
        if (err !== null) {
            throw logger.error('Formulas.ModifyFormula: Formula=' + req.body.formula + ' - Error (Update)=' + JSON.stringify(err));
        }
        
        _this.GetFormulas(db, io, logger, function (FormulasArray) {
            callback(FormulasArray)
        });
    });
};

exports.ValidateFormula = function (req, db, io, logger, callback) {
    
    // Validate the formula
    var validformula = { result: "UNKNOWN" };
    try {
        var expression = mathparser.parse(req.body.Formula);
        logger.info("Formulas.ValidateFormula: Successful parse of '" + req.body.Formula + "'");
        validformula = { result: "TRUE" };// Got here, so it's good!
    }
    catch (err) {
        logger.error("Formulas.ValidateFormula: Unsuccessful parse of '" + req.body.Formula + "' err=" + err);
        validformula = { result : "FALSE" };// Something happened during the parsing
    } finally {
        callback(validformula);
    }
};

exports.EvaluateFormula = function (formula, logger, callback) {
    
    logger.info("Formulas.EvaluateFormula: formula information=" + JSON.stringify(formula));
    var result = _this.CalculateFormula(formula.TestValue, formula, logger);
    logger.info("Formulas.EvaluateFormula: result=" + result);
    callback({ result: result });
}

// Evaluate an existing Formula
exports.CalculateFormula = function (rawValue, formula, logger) {
    
    // Evaluate Formula
    var calculatedResult = "ERROR";
    try {
        var expression = mathparser.parse(formula.Formula);
        //logger.info("Formulas.CalculateFormula: Successful parse of '" + formula.Formula + "' expression='" + expression + "' rawValue=" + rawValue);
        
        var rawResult = expression.evaluate({ x: rawValue });
        //logger.info("Formulas.CalculateFormula: Successful evaluation - result= '" + rawResult + "'");
        
        calculatedResult = Number(rawResult).toFixed(formula.Decimals);
    }
    catch (err) {
        logger.error("Formulas.CalculateFormula: Unsuccessful evaluation of '" + formula.Formula + "' err=" + err);
        calculatedResult = "ERROR";// Something happened during the parsing
    } finally {
        return calculatedResult;
    }
};
//#endregion Formulas API Support
